close all
clc
clear all

np = 1;

k = 1:8;

map = [0.1, 0.1, 0.1, 0.1, 0.1, 0.1 ,0.1, 0.1];
graph = [75.4, 75.5, 60.8,60.4,74.2,73.8,73.6,73.6];
assembly = [140.3, 74.0, 38.,28.6,30.1,25.0,21.4,19.0];

total = map+graph+assembly;

line_width = 1.5;
bar_width = 1;
figure
b1 = bar(k+0.5,map+graph+assembly,bar_width,'r','LineWidth',line_width);
hold on 
b2 = bar(k+0.5,graph+assembly,bar_width,'g','LineWidth',line_width);
b3 = bar(k+0.5,assembly,bar_width,'b','LineWidth',line_width);
xlabel('Threads')
ylabel('Real CPU cost [sec]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,9])
legend([b1,b2,b3],'Map','Graph','Matrix')
%matlab2tikz('mpi_cube_real_CPU_s1.tex')


figure
b1 = bar(k+0.5,(map+graph+assembly)./total,bar_width,'r','LineWidth',line_width);
hold on 
b2 = bar(k+0.5,(graph+assembly)./total,bar_width,'g','LineWidth',line_width);
b3 = bar(k+0.5,assembly./total,bar_width,'b','LineWidth',line_width);
xlabel('Threads')
ylabel('Relative CPU cost [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,9])
legend([b1,b2,b3],'Map','Graph','Matrix', 'Location','SouthEast')
%matlab2tikz('mpi_cube_relative_CPU_s1.tex')

% figure
% b1 = bar(np+0.5,(map+graph+assembly).*np,bar_width,'r','LineWidth',line_width);
% hold on 
% b2 = bar(np+0.5,(graph+assembly).*np,bar_width,'g','LineWidth',line_width);
% b3 = bar(np+0.5,(assembly).*np,bar_width,'b','LineWidth',line_width);
% xlabel('MPI process')
% ylabel('Used CPU cost [sec]')
% set(gca,'fontsize',18)
% grid on
% box on
% xlim([1,20])
% legend([b1,b2,b3],'Map','Graph','Matrix')
%%matlab2tikz('mpi_cube_used_CPU.tex')

line_width = 2;

figure
p1 = plot(k,total(1)./total,'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot(k,k,'r--','LineWidth',line_width);
xlabel('Threads')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,8])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_speed_up_s1.tex')

figure
p1 =plot(k,(total(1))./(total.*k),'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot([1,8],[1,1],'r--','LineWidth',line_width);
xlabel('Threads')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,8])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_scalability_s1.tex')


%%

close all
clc
clear all

np = 16;

k = 1:6;


map = [1.1, 1.1, 1.1, 2.6, 2.7,1.1];
graph = [5.2, 5.2, 5.2, 10.8, 5.2,5.1];
assembly = [8.5, 4.3, 3.0, 2.3, 1.6,1.6];

total = map+graph+assembly;

line_width = 1.5;
bar_width = 1;
figure
b1 = bar(k+0.5,map+graph+assembly,bar_width,'r','LineWidth',line_width);
hold on 
b2 = bar(k+0.5,graph+assembly,bar_width,'g','LineWidth',line_width);
b3 = bar(k+0.5,assembly,bar_width,'b','LineWidth',line_width);
xlabel('Threads')
ylabel('Real CPU cost [sec]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,9])
legend([b1,b2,b3],'Map','Graph','Matrix')
%matlab2tikz('mpi_cube_real_CPU_s2.tex')


figure
b1 = bar(k+0.5,(map+graph+assembly)./total,bar_width,'r','LineWidth',line_width);
hold on 
b2 = bar(k+0.5,(graph+assembly)./total,bar_width,'g','LineWidth',line_width);
b3 = bar(k+0.5,assembly./total,bar_width,'b','LineWidth',line_width);
xlabel('Threads')
ylabel('Relative CPU cost [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,9])
legend([b1,b2,b3],'Map','Graph','Matrix', 'Location','SouthEast')
%matlab2tikz('mpi_cube_relative_CPU_s2.tex')

% figure
% b1 = bar(np+0.5,(map+graph+assembly).*np,bar_width,'r','LineWidth',line_width);
% hold on 
% b2 = bar(np+0.5,(graph+assembly).*np,bar_width,'g','LineWidth',line_width);
% b3 = bar(np+0.5,(assembly).*np,bar_width,'b','LineWidth',line_width);
% xlabel('MPI process')
% ylabel('Used CPU cost [sec]')
% set(gca,'fontsize',18)
% grid on
% box on
% xlim([1,20])
% legend([b1,b2,b3],'Map','Graph','Matrix')
%%matlab2tikz('mpi_cube_used_CPU.tex')

line_width = 2;

figure
p1 = plot(k,total(1)./total,'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot(k,k,'r--','LineWidth',line_width);
xlabel('Threads')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,8])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_speed_up_s2.tex')

figure
p1 =plot(k,(total(1))./(total.*k),'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot([1,8],[1,1],'r--','LineWidth',line_width);
xlabel('Threads')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,8])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_scalability_s2.tex')

%%

figure
p1 = plot(k,assembly(1)./assembly,'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot(k,k,'r--','LineWidth',line_width);
xlabel('Threads')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,8])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_speed_up_s2.tex')

figure
p1 =plot(k,(assembly(1))./(assembly.*k),'-bo',...
                'LineWidth',line_width,...
                'MarkerEdgeColor','b',...
                'MarkerFaceColor',[.49 1 .63],...
                'MarkerSize',10);
hold on
p2 = plot([1,8],[1,1],'r--','LineWidth',line_width);
xlabel('Threads')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,8])
legend([p1,p2],'Actual','Ideal', 'Location','SouthEast')
%matlab2tikz('mpi_cube_scalability_s2.tex')


%%

close all
clc
clear all

np = 16;
k = 6;

n_iter = linspace(1,500,200);

map = [1.1,1.1];
graph = [5.1,5.1];
assembly = [8.5,1.6];

for i=1:length(n_iter)
    total(i,:) = map(:)+graph(:)+n_iter(i)*assembly(:);
end

line_width = 2;

figure
p1 = plot(n_iter,total(:,1)./total(:,2),'-b',...
                'LineWidth',line_width);
hold on
p2 = plot([1,max(n_iter)],[k,k],'r--','LineWidth',line_width);
p3 = plot([1,max(n_iter)],[assembly(1)/assembly(2),assembly(1)/assembly(2)],'g--','LineWidth',line_width);
xlabel('Number of linear iterations')
ylabel('Speedup [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,max(n_iter)])
ylim([1,6])
legend([p1,p2,p3],'Actual','Ideal','Theoretical limit', 'Location','SouthEast')
%matlab2tikz('cube_linear_speed.tex')

figure
p1 =plot(n_iter,total(:,1)./(total(:,2)*k),'-b',...
                'LineWidth',line_width);
hold on
p2 = plot([1,max(n_iter)],[1,1],'r--','LineWidth',line_width);
p3 = plot([1,max(n_iter)],[assembly(1)/(6*assembly(2)),assembly(1)/(6*assembly(2))],'g--','LineWidth',line_width);
xlabel('Number of linear iterations')
ylabel('Efficiency [-]')
set(gca,'fontsize',18)
grid on
box on
xlim([1,max(n_iter)])
ylim([0,1])
legend([p1,p2,p3],'Actual','Ideal','Theoretical limit', 'Location','SouthEast')
%matlab2tikz('cube_linear_sca.tex')
